local addonInfo, privateVars = ...

function nkCurrency.nkPanelPlugin ()

	local plugin = nkPanel.api.plugin('nkCurrency', true, false)

	local name = 'nkCurrency'
	
	plugin:SetThumb('nkCurrency', 'gfx/nkPanelIcon.png')
	
	local body = plugin:CreateBody()
	
	body:SetWidth(400)
	body:SetHeight(146)

	local selection = {}
	for k, v in pairs (Inspect.Currency.Category.List()) do
		local details = Inspect.Currency.Category.Detail(k)
		if details ~= nil then
			table.insert(selection, { label = details.name, value = details.id})
		end
	end
	
	plugin.categorySelect = EnKai.uiCreateFrame("nkCombobox", name .. '.categorySelect', body)
	plugin.categorySelect:SetPoint("TOPLEFT", body, "TOPLEFT", 2 , 2)
	plugin.categorySelect:SetWidth(100)
	plugin.categorySelect:SetHeight(16)
	plugin.categorySelect:SetLabelWidth(0)	
	plugin.categorySelect:SetSelection(selection)
	plugin.categorySelect:SetColorInner({r = 0, g = 0, b = 0, a = 1})
	
	if nkCTSetup.selectedCurrency == nil then nkCTSetup.selectedCurrency = selection[1].value end
	
	plugin.categorySelect:SetSelectedValue(nkCTSetup.selectedCurrency, false)
	plugin.categorySelect:SetColor(0.925, 0.894, 0.741, 1)
	plugin.categorySelect:SetLabelColor(0.925, 0.894, 0.741, 1)
	plugin.categorySelect:SetColorSelected(0.925, 0.894, 0.741, 1)
	plugin.categorySelect:SetLayer(9)
	
	Command.Event.Attach(EnKai.events[name .. '.categorySelect'].ComboChanged, function (_, newValue)
		nkCTSetup.selectedCurrency = newValue.value
		nkCurrency.CurrencyChange (nil, Inspect.Currency.List())
	end, name .. '.categorySelect.ComboChanged')
	
	local grid = EnKai.uiCreateFrame("nkGrid", name .. '.grid', body)
		
	grid:SetHeaderHeight(15)
	grid:SetHeaderFontSize(11)
	grid:SetFontSize(11)
	grid:SetPoint("TOPLEFT", plugin.categorySelect, "BOTTOMLEFT", 0, 5)	
	grid:SetHeaderLabelColor(0.925, 0.894, 0.741, 1)
	grid:SetBorderColor(0.925, 0.894, 0.741, .2)
	grid:SetBodyColor(0, 0, 0, 0)
	
	local cols = {	{ align = 'left', width = 200, header = "Currency"  },
					{ align = 'center', width = 150, header = "Current"},	
					{ align = 'center', width = 50, header = "Max"}}
	
	grid:SetVisible(true)	
	grid:Layout (cols, 6)
	
	Command.Event.Attach(EnKai.events[name .. '.grid'].GridFinished, function ()
		local currencyInfo = Inspect.Currency.List()
		local func = function () nkCurrency.CurrencyChange (nil, currencyInfo) end
		plugin:SetUpdate(func, true, 2)
		body:SetWidth(grid:GetWidth()+4)
	end, name .. '.grid.GridFinished')	
	
	Command.Event.Attach(EnKai.events[name .. '.grid'].LeftClick, function (_, rowNo)
		if nkCTSetup.titleCurrency == grid:GetKey(rowNo) then			
			nkCTSetup.titleCurrency = nil
		else 				
			nkCTSetup.titleCurrency = grid:GetKey(rowNo)
			nkCurrency.CurrencyChange (nil, Inspect.Currency.List())
		end
	end, name .. '.grid.LeftClick')	
	
	function plugin:PopulateGrid(gridValues)
		grid:SetRowPos(1, false)
		grid:SetCellValues(gridValues)
	end
	
	function plugin:ShowGrid(flag) end

	return plugin

end